unit Plate;

interface

uses {$IFDEF MSWINDOWS} Windows, {$ENDIF}
     Graphics, Classes;

function PixelSum(Rect: TRect; Bitmap: TBitmap; var nPixels: Integer): Double;

implementation

uses Types;

{$IFNDEF MSWINDOWS}
{ TODO: Check byte order }
function GetRValue(Color: TColor): Integer;
begin
  Result := Color and $ff;
end;

function GetGValue(Color: TColor): Integer;
begin
  Result := (Color shr 8) and $ff;
end;

function GetbValue(Color: TColor): Integer;
begin
  Result := (Color shr 16) and $ff;
end;

{$ENDIF}

function PixelSum(Rect: TRect; Bitmap: TBitmap; var nPixels: Integer): Double;
var
  SweepY: Boolean;
  x, y, x1, y1, Xstep, Ystep, DeltaX, DeltaErr, Error: Integer;
  procedure HandlePoint;
  var
    Pixel: TColor;
    xp, yp: Integer;
  begin
    if SweepY then begin
      yp := x;
      xp := y;
    end else begin
      yp := y;
      xp := x;
    end;
    Pixel := Bitmap.Canvas.Pixels[xp,yp];
    if (Pixel = -1) or (Pixel = clAqua) then
      Exit; { Out of range }
    Result := Result + GetRValue(Pixel) + GetGValue(Pixel) + GetBValue(Pixel);
    Inc(nPixels);
    Bitmap.Canvas.Pixels[xp,yp] := clAqua;
  end;
begin
  Result := 0;
  nPixels := 0;
  { Step though line with Bresenham's algorithm }
  with Rect do begin
    SweepY := Abs(Top-Bottom) > Abs(Left-Right);
    if SweepY then begin
      x := Bitmap.Height - Top - 1;
      y := Left;
      x1 := Bitmap.Height - Bottom - 1;
      y1 := Right;
    end else begin
      y := Bitmap.Height - Top - 1;
      x := Left;
      y1 := Bitmap.Height - Bottom - 1;
      x1 := Right;
    end;
  end;
  DeltaX := abs(x1 - x);
  DeltaErr := abs(y1 - y);
  Error := 0;
  if x < x1 then
    Xstep := 1
  else
    Xstep := -1;
  if y < y1 then
    Ystep := 1
  else
    Ystep := -1;
  HandlePoint;
  while x <> x1 do begin
    Inc(x, Xstep);
    Inc(Error, DeltaErr);
    if 2*Error >= DeltaX then begin
      Inc(y, Ystep);
      Dec(Error, DeltaX);
    end;
    HandlePoint;
  end;
end;

end.
